<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      <b-form
        class="p-2"
        @submit.stop.prevent  
      >
        <div class = "title">
          <h4>Configurar horario laboral</h4>
        </div>
        <br>
          
          <b-form-group
              label="Seleccione la hora de inicio de la jornada laboral:"
              label-for="timepicker-check-in"
              class="w-50"
            >
  
            <b-form-timepicker
              id="timepicker-check-in"
              placeholder="Escoger hora"
              v-model="formData.check_in_time"
              local="en"
            />
              
          </b-form-group>

          <b-form-group
              label="Seleccione la hora de terminación de la jornada laboral:"
              label-for="timepicker-check-out"
              class="w-50"
            >
  
            <b-form-timepicker
              id="timepicker-check-out"
              placeholder="Escoger hora"
              v-model="formData.check_out_time"
              local="en"
            />
              
          </b-form-group>

          <b-form-group
            label="Tiempo de tolerancia en retardos (minutos)"
            label-for="time"
            class="w-50"
          >
              
            <b-form-input
              id="time"
              v-model="formData.delay_tolerance"
              type="number"
              :state="validationTime"
              onKeyUp=" if (this.value.length > 4) {this.value = this.value.slice(0, 4)} if(this.value<0){this.value= this.value * -1}"
              placeholder="Tiempo de tolerancia (minutos)"
            />
            <b-form-invalid-feedback :state="validationTime">
                Este campo es obligatorio
            </b-form-invalid-feedback>
          </b-form-group>

          <div class="d-flex mt-2">
            <b-button
              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmit"
              @click="handleSubmit()"
            >
              Guardar
            </b-button>
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, BCard, BAlert, BLink,BFormTimepicker
} from 'bootstrap-vue'

export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BFormTimepicker

 
  },

  data(){
    return{
      formData:{
        check_in_time:'',
        check_out_time:'',
        delay_tolerance:0

      },
      lockedSubmit:false,
      errorMessageRequest:''

    }
  },
  methods:{
    handleSubmit(){

      if(this.formData.name===''){
          this.showAlert=true
          return
      }else{
        this.$swal({
          title: '¿Está seguro de actualizar el horario laboral?',
          text: "Se reemplazarán los datos modificados!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            
            this.$http.post('user/attendance/config/edit',this.formData).then(res =>{
              this.$swal({
                  icon: 'success',
                  title: 'Guardado!',
                  text: 'El registro ha sido actualizado.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
              })
            }).catch(err=>{
              if (err.response.status == 422){
                console.log('err')
            
              }
            })
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El registro esta a salvo :)',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
            
      }
    },
    getConfigData(){
      this.$http.get('user/attendance/config',{params:{id:this.$route.params.id}}).then(res=>{
        console.log(res)
        this.formData.check_in_time=res.data.config.check_in_time
        this.formData.check_out_time= res.data.config.check_out_time
        this.formData.delay_tolerance = res.data.config.delay_tolerance
      }).catch(function (error){
        console.log(error)

      })
    }
  },
   computed: {
      validationTime() {
        if(this.formData.delay_tolerance != '' ){
          this.lockedSubmit = false
          return true 
        }else{
          this.lockedSubmit = true
          return false 
        }
       
      },
    
      
     
    },
  
  mounted(){
    this.getConfigData()
  }

}
</script>

<style>

</style>
